// UTF-8 Utility functions
// 2003:3:22

#include <string.h>
#include <stdio.h>
#include "utfutil.h"


//#define RXDEBUG

#ifdef	RXDEBUG
 #define DPRINTF(s) printf s; fflush(stdout);
#else
 #define DPRINTF(s)
#endif

// for temporary quick-checks...
// Always on:
#define XDPRINTF(s) printf s; fflush(stdout);
// Always off:
#define ZDPRINTF(s)


//////////////////////////////////////////////////////////////////////////////

#define BEGINS_CHAR(byte) ((byte & 0xc0) != 0x80)

// This may work...:
#define BAD_UTF_CHAR 0x7F

// These assume valid UTF8 strings!
// If non-UTF8 is encountered, it does its best, but will probably be wrong...
// Eventually, these will presumably be library functions, but for now...

int utf2istep(char *& pt)
{
	ZDPRINTF(("at char %c %x\n", *pt, *pt);)
	if ((*pt & 0x80) == 0) return *pt++;	// just ascii
	int t = *pt++;
	if ((t & 0x40) == 0) return t & 0xff;	// return the bad character anyway
	t = t<<6 | (*pt++ & 0x3F);
	if ((t & 0x800) == 0) 	// two byte group
		return t & 0x7FF;
	else	// ignoring four-byte rarity...
		return ((t & 0x3FF)<<6 | (*pt++ & 0x3F));
}

int utf2i(char * pt)
{
	return utf2istep(pt);	// xame but use temp pointer...
}

char * utfstep(char *& pt, int n)
{
	// caution: this doesn't know about end-of-string!
	while (n--) {
		if ((*pt & 0xe0) == 0xe0) pt +=3;
		else if ((*pt++ & 0xc0) == 0xc0) pt++;
	}
	return pt;
}

long utflen(char *pt)
{
	long count = 0; 
	while ( *pt != '\0' ) { 
		if ((*pt & 0xe0) == 0xe0) pt +=3;
		else if ((*pt++ & 0xe0) == 0xc0) pt++;
		count++;
	}
	return count;
}

//////////////////////////////////////////////////////////////////////////////
